function dpJ = getdpJforcePoles(p,K,m,j,ORDL,ORDF,almj,blmj)
% matrix of dpJ_ll values for a given value of m,j
% indices are l,j,m in that order

% WARNING: THIS HAS NOT BEEN DEBUGGED

%almj = @(l,m,j) sqrt((l-m)*(l+m)*(l-j)*(l+j)/(l^2*(4*l^2-1)));
%blmj = @(l,m,j) m*j/(l*(l+1));
MMAX = (size(almj,2)-1)/2;
ji = j+1; mi = m+1;

mh = max(m,abs(j));

%ORDF = 50; % depth of continued fraction
dpJ= zeros(1,ORDL+1);
wm = zeros(ORDL+1+mh,1); dpjm = zeros(ORDL+1+mh,1);
wp = zeros(ORDL+mh+2,1); dpjp = zeros(ORDL+mh+2,1);

% get the dpj+ terms going down in l
wp(ORDF+mh+2) = 0; dpjp(ORDF+mh+2) = 1; %jp = 0;
for l = ORDF+mh:-1:mh        
    dpjp(l+1) = 1 - (almj(l+2-mh,ji,mi)*K)^2*wp(l+2)^2*dpjp(l+2);    
    wp(l+1) = 1/(p+l*(l+1)-i*K*blmj(l+1-mh,ji,mi)+(almj(l+2-mh,ji,mi)*K)^2*wp(l+2));
end

% get the wm terms and the dpjm
dpjm(mh+1) = 1;
for l = mh+1:ORDL+mh
    wm(l) = (-p-l*(l+1)+i*K*blmj(l+1-mh,ji,mi)-(almj(l+2-mh,ji,mi)*K)^2*wp(l+2))/(almj(l+1-mh,ji,mi)*K)^2;
    dpjm(l+1) = 1 - (almj(l+1-mh,ji,mi)*K)^2*wm(l)^2*dpjm(l);
end

% get the overall dpJ
for l = mh:ORDL+mh
    if (l>mh)
        dpJ(l+1-mh) = -(almj(l+1-mh,ji,mi)*K)^2*wm(l)^2*dpjm(l) +1 - (almj(l+2-mh,ji,mi)*K)^2*wp(l+2)^2*dpjp(l+2);
    else
        dpJ(l+1-mh) = 1 - (almj(l+2-mh,ji,mi)*K)^2*wp(l+2)^2*dpjp(l+2);
    end
end

